#!/usr/bin/env python

import urllib, os
from os.path import exists
from xml.etree.ElementTree import ElementTree
import UI
import hashlib
import gtk
import gzip

class  Updater:
    def dl_file(self, server_path,  local_path):
        url = str(self.host)+str(server_path)
        target = self.UIFolder+local_path
        urllib.urlretrieve(url+str('.gz'), target+str('.gz'), self.ui.pulse_file)
	f_in = gzip.open(target+str('.gz'), 'rb')
	f_out = open(target, 'wb')
	f_out.writelines(f_in)
	f_in.close()
	f_out.close()
	os.remove(target+str('.gz'))
        return True
    
    def getmd5(self,  filename):
        try:
            file = open(filename,  "r")
            md5 = hashlib.md5()
            md5.update(file.read())
            file.close()
            md5sum = md5.hexdigest()
            return md5sum
        except IOError:
            return False
    
    def update(self,  w,  ui):
        if exists(self.UIFolder) == False:
            os.mkdir(self.UIFolder)
	    os.mkdir(self.UIFolder+"POI")
            os.mkdir(self.UIFolder+"images")
	    os.mkdir(self.UIFolder+"images/maps")
            os.mkdir(self.UIFolder+"images/icons")
            os.mkdir(self.UIFolder+"eq2map2")
        elif exists(self.UIFolder+"images") == False:
            os.mkdir(self.UIFolder+"images")
	    os.mkdir(self.UIFolder+"images/maps")
            os.mkdir(self.UIFolder+"images/icons")
        elif exists(self.UIFolder+"eq2map2") == False:
            os.mkdir(self.UIFolder+"eq2map2")
	    if exists(self.UIFolder+"POI") == False:
	        os.mkdir(self.UIFolder+"POI")
	elif exists(self.UIFolder+"POI") == False:
            os.mkdir(self.UIFolder+"POI")
        
        self.updating = 1
        ui.push_status("Connecting to server...")
        tree = ElementTree()
	urllib.urlretrieve(self.host+self.xml_indexfile, self.xml_indexfile, ui.pulse)
	f_index = gzip.open(self.xml_indexfile, 'rb')
        tree.parse(f_index)
	f_index.close()
	os.remove(self.xml_indexfile)
        extra = tree.getiterator("Extra")
        tfn = len(extra)
        i = 1
        dllist = []
        ui.push_status("Scaning for updated files!")
        for n in extra:
            if self.updating:
                self.count_total = float(i) / float(tfn)
                file = self.UIFolder+n.findtext("LocalPath")+n.findtext("FileName")
                md5sum = self.getmd5(file)
                if md5sum:
                    if md5sum != n.findtext("MD5") and n.findtext("MD5") != "exist":
                        dllist.append([n.findtext("FileName") , n.findtext("Name") , n.findtext("LocalPath") , n.findtext("ServerPath")])
                else:
                    dllist.append([n.findtext("FileName") , n.findtext("Name") , n.findtext("LocalPath") , n.findtext("ServerPath")])
                ui.pulse_total(self.count_total)
            else:
                ui.push_status("Update Aborted by User!")
                return
            i = i + 1
        
        self.count_total = 0.0
        d = 1
        tdn = len(dllist)
        
        for f in dllist:
            if self.updating:
                self.count_total = float(d) / float(tdn)
                ui.push_status("Downloading: "+f[1])
                file = f[3]+f[0]
                target = f[2]+f[0]
                if exists(self.UIFolder+f[2]):
                    self.dl_file(file,  target)
                else:
                    os.mkdir(self.UIFolder+f[2])
                    self.dl_file(file,  target)
                ui.pulse_total(self.count_total)
            else:
                ui.push_status("Update Aborted by User!")
                return
            d = d + 1
        
        ui.push_status("Update Compleat! "+str(tdn)+" files updated.")
        return True
    
    def cancel(self,  w,  ui):
        self.updating = 0
        return True

    def quit_app(self, widget, data=None):
        gtk.main_quit()
    def loadSettings(self):
        self.settings.parse("Settings.xml")
        self.host = self.settings.findtext("HOST")
        self.xml_indexfile = self.settings.findtext("LISTFILE")
        self.UIFolder = self.settings.findtext("UIFOLDER")
    def saveSettings(self,  ui):
        self.host = ui.hostfeeld.get_text()
        self.xml_indexfile = ui.listfilefeeld.get_text()
        self.UIFolder = ui.filechoser.get_filename()+"/"
        self.settings.find("HOST").text = self.host
        self.settings.find("LISTFILE").text = self.xml_indexfile
        self.settings.find("UIFOLDER").text = self.UIFolder
        self.settings.write("Settings.xml")
        return
    def __init__(self):
        #Settings
        self.settings = ElementTree()
        self.loadSettings()
        
        self.updating = 0
        self.count_total = 0.0
        hook = False
        
        # Load the UI
        self.ui = UI.UI(self)
        

def main():
    gtk.main()
    return 0

Updater()
main()
